<?php

$it_author = 'Lsansan';
$it_authorurl = 'https://blog.luojiasan.com';
$it_plugin = 'Lsansan sitemap';
$it_pluginversion = '1.1.3';
$it_pluginurl = 'https://blog.luojiasan.com';

if(!function_exists('file_get_contents')){
	function file_get_contents($filename, $incpath = false, $resource_context = null){
		if(false === $fh = fopen($filename, 'rb', $incpath)){
			user_error('file_get_contents() 无法打开 sitemap.html 文件：未找到该文件。', E_USER_WARNING);
			return false;
		}
		clearstatcache();
		if($fsize = filesize($filename)){$data = fread($fh, $fsize);}
		else{$data = '';while(!feof($fh)){$data .= fread($fh, 8192);}
		}
		fclose($fh);return $data;
	}
}

if(!function_exists('file_put_contents')){
	if(!defined('FILE_USE_INCLUDE_PATH')){define('FILE_USE_INCLUDE_PATH', 1);}
	if(!defined('LOCK_EX')){define('LOCK_EX', 2);}	
	if(!defined('FILE_APPEND')){define('FILE_APPEND', 8);}
	function file_put_contents($filename, $content, $flags = null, $resource_context = null){
		if(is_array($content)){$content = implode('', $content);}
		if(!is_scalar($content)){
			user_error('file_put_contents() 函数的第二个参数应该是字符串或数组。',E_USER_WARNING);return false;
		}
		$length = strlen($content);
		$mode =($flags & FILE_APPEND)?'a':'wb';
		$use_inc_path =($flags & FILE_USE_INCLUDE_PATH)?true:false;
		if(($fh = fopen($filename, $mode, $use_inc_path)) === false){
			user_error('file_put_contents() 函数无法打开文件：权限被拒绝。',E_USER_WARNING);return false;
		}
		$use_lock =($flags & LOCK_EX) ? true : false ;
		if($use_lock === true){if(!flock($fh, LOCK_EX)){return false;}}
		$bytes = 0;
		if(($bytes = fwrite($fh, $content)) === false){
			$errormsg = sprintf('file_put_contents() 函数 %d 字节写入 %s 失败。',$length,$filename);user_error($errormsg,E_USER_WARNING);return false;
		}
		fclose($fh);
		if($bytes != $length){
			$errormsg = sprintf('file_put_contents() 仅写入了 %d 字节中的 %d 字节，可能磁盘空间不足。',$bytes,$length);user_error($errormsg, E_USER_WARNING);return false;
		}
		return $bytes;
	}
}

if(!function_exists('IT_GetHomePath')){function IT_GetHomePath(){$res="";if(function_exists("get_home_path")){$res = get_home_path();}return $res;}}
function IT_EscapeXML($string){return str_replace(array('&','"',"'",'<','>'),array('&amp;','&quot;','&apos;','&lt;','&gt;'),$string);}
if(!function_exists('IT_GetPluginPath')){function IT_GetPluginPath(){$path = dirname(__FILE__);return trailingslashit(str_replace("\\","/",$path));}}

if(!function_exists('IT_IsFileWritable')){
	function IT_IsFileWritable($filename){
		clearstatcache();
		if(!is_writable($filename)){
			if(!chmod($filename, 0666)){
				$pathtofilename = dirname($filename);
				if(!is_writable($pathtofilename)){if(!chmod($pathtoffilename, 0666)){return false;}}
			}
		}
		return true;
	}
}

function IT_rebuild_message(){
	if(function_exists("wp_next_scheduled")){
		baidu_sitemap_is_auto_daily();
		$next = wp_next_scheduled('do_baidu_sitemap_auto_daily');
		if($next){
			$diff =(time()-$next)*-1;
			if($diff <= 0){$diffMsg = '每日自动生成地图功能开启中............';}
			else{
				if($diff > 3600){
					$hours = intval($diff / 3600);
					$diff = $hours . "小时" . gmstrftime('%M分%S秒', $diff);
				}
				else{
					$diff = gmstrftime('%H小时%M分%S秒', $diff);
				}
				$diffMsg = str_replace("%s",$diff,'在 %s 之后将会自动更新 Sitemap 文件。');
			}
		}
		else{$diffMsg = '未勾选生成地图选项，每日自动生成功能已关闭............';}
		echo "<strong><p>$diffMsg</p></strong>";	
	}
}

function IT_rebuild_baidu_submit_message(){
	if(function_exists("wp_next_scheduled")){
		baidu_submit_sitemap_is_auto_daily();
		$next = wp_next_scheduled('do_baidu_submit_sitemap_auto_daily');
		if($next){
			$diff =(time()-$next)*-1;
			if($diff <= 0){$diffMsg = '每日自动提交百度功能开启中............';}
			else{
				if($diff > 3600){
					$hours = intval($diff / 3600);
					$diff = $hours . "小时" . gmstrftime('%M分%S秒', $diff);
				}
				else{
					$diff = gmstrftime('%H小时%M分%S秒', $diff);
				}
				$diffMsg = str_replace("%s",$diff,'在 %s 之后将会自动推送网站 url 到百度。');
			}
		}
		else{$diffMsg = '未勾选每日自动提交选项，自动推送功能已关闭............';}
		echo "<strong><p>$diffMsg</p></strong>";	
	}
}

function xml_file_exist(){
	echo '<div class="tool-box" style="clear:both;">';
	$filename = array('xml','html','txt','log');
	foreach($filename as $file_names){
		$file_name = IT_GetHomePath().'sitemap.'.$file_names;
		check_files_status($file_name,$file_names);
	}
	echo '</div>';
}
function check_files_status($filename,$file_name){
	$it_blog_url = home_url();
	if(file_exists($filename)){
		$filemtime=date("Y年m月d日 H:i:s",filemtime("$filename"));
		$url = $it_blog_url.'/sitemap.'.$file_name;
		echo '<p>检查 '.$file_name.' 文件：'; echo '<a href="'.$url.'" target="_blank">'.$url.'</a> 上次更新时间：'.$filemtime.'</p>';
	}
	else{echo '还没有创建过Sitemap.'.$file_name.'文件<br>';}
}

function xml_annotate(){
	global $it_author, $it_authorurl, $it_plugin, $it_pluginversion, $it_pluginurl, $wp_version;
	$blogtime = current_time('mysql'); 
	list(
		$today_year,
		$today_month,
		$today_day,
		$hour,
		$minute,
		$second 
	) = preg_split( '([^0-9])', $blogtime );
	$xml_author_annotate = '<!-- baidu-sitemap-generator-version="'.$it_pluginversion.'" --><!-- generated-on="'."$today_year-$today_month-$today_day $hour:$minute:$second".'" -->';
    return $xml_author_annotate;
}

function IT_GetTimestampFromMySql($mysqlDateTime){
	list($date, $hours) = explode(' ', $mysqlDateTime);
	list($year,$month,$day) = explode('-',$date);
	list($hour,$min,$sec) = explode(':',$hours);
	return mktime(intval($hour), intval($min), intval($sec), intval($month), intval($day), intval($year));
}
?>